SystemOrganization addCategory: #'Pier-Forms'!

PRStructure subclass: #PRForm
	instanceVariableNames: 'model metamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Forms'!

!PRForm class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isAbstract
	^ false! !

!PRForm methodsFor: 'visiting' stamp: 'lr 1/22/2007 20:30'!
accept: aVisitor
	aVisitor visitForm: self! !

!PRForm methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2007 12:53'!
cssClass
	^ 'form'! !

!PRForm methodsFor: 'accessing-dynamic' stamp: 'lr 5/24/2006 15:16'!
description
	"Answer a generic description with the properties of the structure and with the defined fields of the receiver to make all the data properly editable and searchable."

	^ (MAContainer withAll: super description) , (self metamodel do: [ :each | each beEditable ])! !

!PRForm methodsFor: 'accessing-dynamic' stamp: 'lr 5/26/2007 09:43'!
document
	^ PRDocument new
		add: (PRTable new
			add: (self metamodel children collect: [ :each |
				PRTableRow new
					add: (PRTableCell with: (PRBoldFormat with: (PRText content: each label)));
					add: (PRTableCell with: (PRText content: (each toString: (self readUsing: each))));
					yourself ]);
			yourself);
		yourself! !

!PRForm methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self model: Dictionary new.
	self metamodel: MAContainer new! !

!PRForm methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
metamodel
	^ metamodel! !

!PRForm methodsFor: 'accessing' stamp: 'lr 3/12/2006 01:49'!
metamodel: aDescription
	metamodel := aDescription! !

!PRForm methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
model
	^ model! !

!PRForm methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
model: aDictionary
	model := aDictionary! !

!PRForm methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self model: self model copy! !

!PRForm methodsFor: 'private' stamp: 'lr 3/12/2006 01:47'!
readUsing: aDescription
	^ (self metamodel includes: aDescription)
		ifFalse: [ super readUsing: aDescription ]
		ifTrue: [ self model at: aDescription ifAbsent: [ aDescription default ] ]! !

!PRForm methodsFor: 'private' stamp: 'lr 3/12/2006 01:47'!
write: anObject using: aDescription
	(self metamodel includes: aDescription)
		ifFalse: [ super write: anObject using: aDescription ]
		ifTrue: [ self model at: aDescription put: anObject ]! !

!PRViewRenderer methodsFor: '*pier-forms-seaside-rendering' stamp: 'lr 1/22/2007 20:32'!
visitForm: anObject
	self visit: anObject document! !

!PRVisitor methodsFor: '*pier-forms-visiting-structures' stamp: 'lr 1/22/2007 20:30'!
visitForm: anObject
	self visitStructure: anObject! !

PRCommand subclass: #PREditFormCommand
	instanceVariableNames: 'metamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Forms'!

!PREditFormCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isAbstract
	^ false! !

!PREditFormCommand class methodsFor: 'accessing' stamp: 'lr 3/12/2006 01:53'!
label
	^ 'Edit Form'! !

!PREditFormCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
structureClass
	^ PRForm! !

!PREditFormCommand methodsFor: 'accessing-dynamic' stamp: 'lr 4/10/2006 11:41'!
description
	^ self metamodel description! !

!PREditFormCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doExecute
	super doExecute.
	self structure metamodel: self metamodel! !

!PREditFormCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
metamodel
	^ metamodel ifNil: [ metamodel := self structure metamodel ]! !

!PREditFormCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
metamodel: aDescription
	metamodel := aDescription! !

!PREditFormCommand methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
readUsing: aDescription
	^ self metamodel readUsing: aDescription! !

!PREditFormCommand methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
write: anObject using: aDescription
	self metamodel write: anObject using: aDescription! !
